﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectSeaplane.Drawnings;
/// <summary>
/// сравнение по цвету, скорости и весу
/// </summary>
public class SeaplaneCompareByColor : IComparer<DrawingBasicSeaplane?>
{
    public int Compare(DrawingBasicSeaplane? x, DrawingBasicSeaplane? y)
    {
        if (x == null || x.EntityBasicSeaplane == null)
        {
            return 1;
        }

        if (y == null || y.EntityBasicSeaplane == null)
        {
            return -1;
        }
        var bodycolorCompare = x.EntityBasicSeaplane.BodyColor.Name.CompareTo(y.EntityBasicSeaplane.BodyColor.Name);
        if (bodycolorCompare != 0)
        {
            return bodycolorCompare;
        }
        var speedCompare = x.EntityBasicSeaplane.Speed.CompareTo(y.EntityBasicSeaplane.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return x.EntityBasicSeaplane.Weight.CompareTo(y.EntityBasicSeaplane.Weight);
    }
}
