﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectSeaplane.Drawnings;
/// <summary>
/// Сравнение по типу, скорости, весу
/// </summary>
public class SeaplaneCompareByType : IComparer<DrawingBasicSeaplane?>
{
    public int Compare(DrawingBasicSeaplane? x, DrawingBasicSeaplane? y)
    {
        if (x == null || x.EntityBasicSeaplane == null)
        {
            return 1;
        }
        if (y == null || y.EntityBasicSeaplane == null)
        {
            return -1;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return x.GetType().Name.CompareTo(y.GetType().Name);
        }
        var speedCompare = x.EntityBasicSeaplane.Speed.CompareTo(y.EntityBasicSeaplane.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return x.EntityBasicSeaplane.Weight.CompareTo(y.EntityBasicSeaplane.Weight);
    }
}
