﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace ProjectSeaplane.Exceptions;

/// <summary>
/// Класс, описывающий ошибку добавления в коллекцию одинаковых объектов
/// </summary>
[Serializable]
public class ObjectIsEqualException : ApplicationException
{
    public ObjectIsEqualException(int count) : base("В коллекции содержится равный элемент: " + count) { }
    public ObjectIsEqualException() : base() { }
    public ObjectIsEqualException(string message) : base(message) { }
    public ObjectIsEqualException(string message, Exception exception) : base(message, exception) { }
    protected ObjectIsEqualException(SerializationInfo info, StreamingContext contex) : base(info, contex) { }
}