﻿namespace ProjectSeaplane.MovementStrategy;

public class MoveToBorder : AbstractStrategy
{
    protected override bool IsTargetDestinaion()
    {
        ObjectParameters? objParams = GetObjectParameters;
        if (objParams == null)
        {
            return false;
        }
        return objParams.RightBorder <= FieldWidth &&
            objParams.RightBorder + GetStep() >= FieldWidth &&
            objParams.DownBorder <= FieldHeight &&
            objParams.DownBorder + GetStep() >= FieldHeight;
    }

    protected override void MoveToTarget()
    {
        ObjectParameters? objParams = GetObjectParameters;
        if (objParams == null)
        {
            return;
        }
        int diffX = objParams.RightBorder - FieldWidth;
        if (Math.Abs(diffX) > GetStep())
        {

            if (diffX > 0)
            {
                MoveLeft();
            }
            if (diffX < 0) 
            {
                MoveRight();
            }
        }
        int diffY = objParams.DownBorder - FieldWidth;
        if (Math.Abs(diffY) > GetStep())
        {

            if (diffX > 0)
            {
                MoveUp();
            }
            if (diffY < 0)
            {
                MoveDown();
            }
        }
    }
}
